package net.sf.javaprinciples.resource;

/**
 * Formats a relative directory and a fixed name.
 */
public class GuidFileResolver extends RootFileResolver
{
    private String filename;

    protected String makeFilename(ResourceIdentifier identifier)
    {
        String guid = identifier.getIdentifier();

        return makeDirectory(guid) + "/" + filename;
    }

    protected String makeDirectory(String guid)
    {
        int firstIndex = guid.indexOf('-');
        StringBuffer buffer = new StringBuffer();
        String prefix = guid.substring(0, firstIndex);
        String suffix = guid.substring(firstIndex + 1);

        for (int i = 0; i < prefix.length(); i += 2)
        {
            if (buffer.length() != 0)
            {
                buffer.append("/");
            }
            buffer.append(prefix.charAt(i));
            buffer.append(prefix.charAt(i + 1));
        }
        buffer.append("/");
        buffer.append(suffix);
        return buffer.toString();
    }

    public void setFilename(String filename)
    {
        this.filename = filename;
    }

    public String getFilename()
    {
        return filename;
    }
}
