package net.sf.javaprinciples.resource.servlet;

import javax.servlet.http.HttpServletRequest;

import net.sf.javaprinciples.resource.Resource;
import net.sf.javaprinciples.resource.ResourceException;
import net.sf.javaprinciples.resource.ResourceIdentifier;

public class PostHandler<T> extends AbstractHandler<T>
{
    private static final String LOCATION_HEADER = "Location";

    @Override
    public void handleRequest(ResourceModel<T> model, HttpServletRequest request) throws ResourceException
    {
        ResourceIdentifier identifier = identifierParser.parse(request);
        Resource<T> resource = getResourceFromRequest(request);
        identifier = resourceFactory.putResource(identifier, resource);
        model.setStatusCode(statusCode);
        model.addProperty(LOCATION_HEADER, identifier.getIdentifier());
    }
}